'DirectDraw 7 example for HotBasic v5.0a
'By Don
'February 07, 2007.
'
'note: Tested under Win95OSR2 only. Should work under Win98/ME/XP
'      press ESC to quit application

$apptype GUI
$typecheck ON

' In-case bitmap resource being used.
'$resource IDB_GREENCAR as "greencar.bmp"

$include "hotdd7_supp.inc"

declare sub DD7Init
declare sub DD7Shutdown
declare sub your_OnInitialize
declare sub your_OnActivate

declare sub create_carSprite
declare sub load_carBitmap
declare sub draw_carFlicks (iSrcX as dword, iSrcY as dword)

' ----------------------------------------------------------------------
' Global variables
' ----------------------------------------------------------------------
defint cx, cy

dim    g_cSurface  as LPDIRECTDRAWSURFACE7, _
       g_pDDSBack  as LPDIRECTDRAWSURFACE7, _
       g_pDDSFront as LPDIRECTDRAWSURFACE7, _
       g_pDD       as LPDIRECTDRAW7, _
       ddsd        as DDSURFACEDESC2

' ----------------------------------------------------------------------
' Main Program
' ----------------------------------------------------------------------
funccall(GetSystemMetrics, SM_CXSCREEN): cx = retfunc
funccall(GetSystemMetrics, SM_CYSCREEN): cy = retfunc

create ddwin as form
   caption = "Hot DDraw7 Demo"
   exstyle = WS_EX_TOPMOST
   style   = WS_POPUP
   top     = 0
   left    = 0
   width   = cx
   height  = cy
   color   = &H000000
   onkeydown = keydown
   onclose   = closewin
end create

ddwin.show
ddwin.focus

' Initialize DirectDraw7
DD7Init
if DDRet <> DD_OK then
   showmessage "Minimum requirement is DirectX 7 to run this program"
   app.terminate
end if

' User's OnInitialize code
create_carSprite
load_carBitmap

do
  if wParam = WM_QUIT then ddwin.close
  doevents
  ' User's OnActivate code
  your_OnActivate
loop until ddwin.visible = 0
DD7Shutdown


keydown:
  if wParam = VK_ESCAPE then ddwin.close
  return

closewin:
  if g_pDD then IDirectDraw7_RestoreDisplayMode(g_pDD)
  app.terminate
  return


' ----------------------------------------------------------------------
' DD7Init : DD7 form initialization
' ----------------------------------------------------------------------
sub DD7Init
  dim ddscaps as DDSCAPS2
  
  ' Create a DirectDraw Object 1st
  DirectDrawCreateEx(0, @g_pDD, @IID_IDirectDraw7, 0)
  IDirectDraw7_SetCooperativeLevel(g_pDD, ddwin.handle, DDSCL_EXCLUSIVE + DDSCL_FULLSCREEN)
  IDirectDraw7_SetDisplayMode(g_pDD, 640, 480, 16, 0, 0)

  ' Create Primary surface
  ZeroMemory(@ddsd, sizeof(DDSURFACEDESC2))
  ddsd.dwSize = sizeof(DDSURFACEDESC2)
  ddsd.dwFlags = DDSD_CAPS + DDSD_BACKBUFFERCOUNT
  ddsd.ddsCaps_dwCaps = DDSCAPS_PRIMARYSURFACE + DDSCAPS_FLIP + DDSCAPS_COMPLEX
  ddsd.dwBackBufferCount = 1
  IDirectDraw7_CreateSurface(g_pDD, @ddsd, @g_pDDSFront, 0)

  ' Create the Back Buffer & attach to Primary surface
  ZeroMemory(@ddscaps, sizeof(DDSCAPS2))
  ddscaps.dwCaps = DDSCAPS_BACKBUFFER
  IDirectDrawSurface7_GetAttachedSurface(g_pDDSFront, @ddscaps, @g_pDDSBack)
end sub

' ----------------------------------------------------------------------
' DDShutdown : Shutdown DDraw7 Core Interfaces
' ----------------------------------------------------------------------
sub DD7Shutdown
  if g_cSurface  <> 0 then IUnknown_Release(g_cSurface)
  if g_pDDSBack  <> 0 then IUnknown_Release(g_pDDSBack)
  if g_pDDSFront <> 0 then IUnknown_Release(g_pDDSFront)
  if g_pDD       <> 0 then IUnknown_Release(g_pDD)
end sub









' ----------------------------------------------------------------------
' your_OnActivate : User's activation code / game main
' ----------------------------------------------------------------------
sub your_OnActivate
  begin runonce
    defint iX = 0
    defint iY = 0
  end runonce
  defint iLastBlit, continue = 1

  funccall(GetTickCount)
  if retfunc - iLastBlit < 60 then exit sub
  draw_carFlicks(iX, iY)

  while continue = 1
    IDirectDrawSurface7_Flip(g_pDDSFront, 0, 0)
    if DDRet = DD_OK then continue = 0
    if DDRet = DDERR_SURFACELOST then IDirectDrawSurface7_Restore(g_pDDSFront)
    if DDRet <> DDERR_WASSTILLDRAWING then continue = 0
  wend

  inc(iX, 150)
  if iX >= 1500 then
     iX = 0
     inc(iY, 140)
     if iY >= 280 then iY = 0
  end if

  funccall(GetTickCount)
  iLastBlit = retfunc
end sub


' ----------------------------------------------------------------------
' create_carSprite : create surface for car images
' ----------------------------------------------------------------------
sub create_carSprite
  dim ddck as DDCOLORKEY

  ZeroMemory(@ddsd, sizeof(DDSURFACEDESC2))
  ddsd.dwSize         = sizeof(DDSURFACEDESC2)
  ddsd.dwFlags        = DDSD_CAPS + DDSD_WIDTH + DDSD_HEIGHT
  ddsd.ddsCaps_dwCaps = DDSCAPS_OFFSCREENPLAIN + DDSCAPS_VIDEOMEMORY
  ddsd.dwWidth        = 1500
  ddsd.dwHeight       = 280
  IDirectDraw7_CreateSurface(g_pDD, @ddsd, @g_cSurface, 0)

  if DDRet <> DD_OK then
     if DDRet = DDERR_OUTOFVIDEOMEMORY then
        ddsd.ddsCaps_dwCaps = DDSCAPS_OFFSCREENPLAIN + DDSCAPS_SYSTEMMEMORY
        IDirectDraw7_CreateSurface( g_pDD, @ddsd, @g_cSurface, 0)
     end if
     if DDRet <> DD_OK then exit sub
  end if

  ddck.dwColorSpaceLowValue = -1 'no colorkey
  ddck.dwColorSpaceHighValue = 0
  IDirectDrawSurface7_SetColorKey( g_cSurface, DDCKEY_SRCBLT, @ddck)
end sub

' ----------------------------------------------------------------------
' load_carBitmap : load car bitmap sprite
' ----------------------------------------------------------------------
sub load_carBitmap
  defint hdc
  dim hbm as BITMAP
  
      hbm.width = 1500
      hbm.height = 280
      hbm.recreate

      ' If using bitmap from resource
      'hbm.bmp = "IDB_GREENCAR"

      hbm.loadfromfile "greencar.bmp"

  ' Make sure this surface is restored.
  IDirectDrawSurface7_Restore(g_cSurface)

  ' Get size of surface.
  ddsd.dwSize = sizeof(DDSURFACEDESC2)
  ddsd.dwFlags = DDSD_HEIGHT + DDSD_WIDTH
  IDirectDrawSurface7_GetSurfaceDesc(g_cSurface, @ddsd)

  hdc = IDirectDrawSurface7_GetDC(g_cSurface)
  if DDRet = DD_OK then
      funccall(StretchBlt, hdc, 0, 0, ddsd.dwWidth, ddsd.dwHeight, hbm.dc, 0, 0, 1500, 280, SRCCOPY)
      IDirectDrawSurface7_ReleaseDC(g_cSurface, hdc)
  end if
  hbm.clear
end sub


' ----------------------------------------------------------------------
' draw_carFlicks : animate car sprite
' ----------------------------------------------------------------------
sub draw_carFlicks
  dim rcRect as RECT
  defint continue = 1

  rcRect.left   = iSrcX
  rcRect.top    = iSrcY
  rcRect.right  = 150 + iSrcX
  rcRect.bottom = 140 + iSrcY

  while continue = 1
    IDirectDrawSurface7_BltFast(g_pDDSBack, 245, 170, g_cSurface, @rcRect, DDBLTFAST_NOCOLORKEY)
    'Alternate BltFast with source colorkey
    'IDirectDrawSurface7_BltFast(g_pDDSBack, 245, 170, g_cSurface, @rcRect, DDBLTFAST_SRCCOLORKEY)
    if DDRet = DD_OK then continue = 0
    if DDRet = DDERR_SURFACELOST then 
       IDirectDrawSurface7_Restore(g_cSurface)
    else
       if DDRet <> DDERR_WASSTILLDRAWING then continue = -1
    end if
  wend
end sub


